#include <iostream>
#include <fstream>
#include <algorithm>

typedef long long ll;

using namespace std;

const int maxn=50111, maxm=50111;

int m, n, p;

struct fish_s
{
    int x;
    int a;
};
struct sell_s
{
    int y;
    int b;
    int c;
};

fish_s fish[maxn];
sell_s sell[maxm];

bool sort_f1(sell_s s1, sell_s s2)
{
    return s1.c>s2.c;
}

void input()
{
    cin >>n >>m >>p;
    int i;
    for (i=0; i<n; ++i)
        cin >>fish[i].x >> fish[i].a;
    for (i=0; i<m; ++i)
        cin >>sell[i].y >>sell[i].b >>sell[i].c;
}
void solve_I_group()
{
    int i;
    long long f_sum=0; //сколько рыбы всего
    for (i=0; i<n; ++i) f_sum+=fish[i].a;

    long long ans=0;
    sort(&sell[0], &sell[m], sort_f1);

    long long d; //сколько куплено на этом участке
    for (i=0; i<m; ++i)
    {
        d=min(f_sum, (long long) sell[i].b);
        ans+=ll(d)*ll(sell[i].c);
        f_sum-=d;
    }
    cout <<ans <<endl;
    return;
}

int main()
{
    freopen("fisher.in", "r", stdin);
    freopen("fisher.out", "w", stdout);
    input();
    if (p==0) solve_I_group();
    return 0;
}
/*
3 2 0
1 5
2 3
4 5
2 2 10
3 6 5
*/
